#include <windows.h>
#define MAX_LOADSTRING 100

// Global Variables:
HINSTANCE  hInst;            // The current instance

// Foward declarations of functions included in this code module:
ATOM MyRegisterClass (HINSTANCE hInstance, LPTSTR szWindowClass);
BOOL InitInstance (HINSTANCE, int);
LRESULT CALLBACK WndProc (HWND, UINT, WPARAM, LPARAM);
void MyPaint (HWND, UINT, WPARAM, LPARAM);


//used to hook the taskbar
HWND g_hWndMain = NULL;  //handle to the main application
HWND g_hWndTask = NULL;  //taskbar window handle
WNDPROC g_fnProcTask = NULL;  //taskbars original windproc
LRESULT CALLBACK TaskWndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam); //new taskbar wndproc


// Hook into the task bar -- called at the end of InitInstance() // 
BOOL HookTaskBar() 
{ 
	// Already hooked? // 	
	if(g_fnProcTask) 
		return FALSE; 
	
	g_hWndTask = ::FindWindow(_T("HHTaskBar"), _T("")); 
		
	if(g_hWndTask)
	{
		g_hWndMain = ::GetForegroundWindow();
		g_fnProcTask = (WNDPROC)::GetWindowLong(g_hWndTask, GWL_WNDPROC);
		::SetWindowLong(g_hWndTask, GWL_WNDPROC, (LONG)TaskWndProc);		
	}
	
	return g_hWndTask != NULL;
}


 // Free the task bar -- called when window is made unactive// 
BOOL FreeTaskBar() 
{
	// // Already freed? // 
	if(!g_fnProcTask)
		return FALSE; 
	
	::SetWindowLong(g_hWndTask, GWL_WNDPROC, (LONG)g_fnProcTask);
	g_fnProcTask = NULL; 
	
	return TRUE; 
}


// TaskWndProc // 
// Handles the WM_LBUTTONUP message // 
LRESULT CALLBACK TaskWndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam) 
{
	if(msg == WM_LBUTTONUP) 
	{ 
		RECT rc; 
		POINT pt; 
		rc.left = 240 - 26; 
		rc.top = 0; 
		rc.bottom = 26; 
		rc.right = 240; 
		pt.x = LOWORD(lParam); 
		pt.y = HIWORD(lParam); 
		
		if(::PtInRect(&rc, pt)) 
		{ 
			::PostMessage(g_hWndMain, WM_CLOSE, 0, 0); 
			return ::CallWindowProc( g_fnProcTask, hWnd, WM_MOUSEMOVE, 0, MAKELPARAM(200, 0)); 
		} 
	} 
	
	return ::CallWindowProc(g_fnProcTask, hWnd, msg, wParam, lParam); 
}


int WINAPI WinMain(    HINSTANCE hInstance,
									 HINSTANCE hPrevInstance,
									 LPTSTR    lpCmdLine,
									 int       nCmdShow)
{
	MSG msg;
	
	
	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}
	
	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
		
	}
	
	
	return msg.wParam;
}

//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage is only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance, LPTSTR szWindowClass)
{
	WNDCLASS    wc;
	
	wc.style            = CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc     = (WNDPROC) WndProc;
	wc.cbClsExtra         = 0;
	wc.cbWndExtra       = 0;
	wc.hInstance            = hInstance;
	wc.hIcon                  = 0;
	wc.hCursor               = 0;
	wc.hbrBackground   = (HBRUSH) GetStockObject(WHITE_BRUSH);
	wc.lpszMenuName   = 0;
	wc.lpszClassName    = szWindowClass;
	
	return RegisterClass(&wc);
}

//
//  FUNCTION: InitInstance(HANDLE, int)
//
//  PURPOSE: Saves instance handle and creates main window
//
//  COMMENTS:
//
//    In this function, we save the instance handle in a global variable and
//    create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
	TCHAR    szTitle[MAX_LOADSTRING];                       // The title bar text
	TCHAR    szWindowClass[MAX_LOADSTRING];        // The window class name
	HWND hWnd;
	
	// Store instance handle in our global variable
	hInst = hInstance;        
	
	// Initialize global strings
	MyRegisterClass(hInstance, szWindowClass);	
	
	wcscpy(szTitle,_T("SUBCLASS ME !!!"));

	hWnd = CreateWindow(szWindowClass, szTitle, 
		WS_VISIBLE,
		0, 0, 
		CW_USEDEFAULT,  
		CW_USEDEFAULT, 
		NULL, NULL, hInstance, NULL);	
	
	if (!hWnd)
	{    
		return FALSE;
	}
	
	HookTaskBar();
		
  return TRUE;
}

//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND    - process the application menu
//  WM_PAINT    - Paint the main window
//  WM_DESTROY    - post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, 
												 UINT message, 
												 WPARAM wParam,
												 LPARAM lParam)
{	
	switch (message) 
	{
		
		case WM_CREATE:
			break;
			
				case WM_PAINT:
					{
						MyPaint(hWnd, message, wParam, lParam);
						break;
					}
					
				case WM_DESTROY:
					PostQuitMessage(0);
					break;
					
				case WM_ACTIVATE:
					{
						//HookTaskBar(); 
						
						if (WA_INACTIVE == LOWORD(wParam))
							FreeTaskBar(); 
					}
					break;
					
				case WM_CLOSE:
					{
						//do something here when close message is recieved from subclassed taskbar on minimize
					}
					break;
					
										
				default:
					return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}


void MyPaint(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{	
	HDC hdc;
	PAINTSTRUCT ps;
	RECT			rcWindBounds; 
	RECT			rcMyBounds;
		
	GetWindowRect( hWnd, &rcWindBounds); 	
	
	hdc = BeginPaint(hWnd, &ps);
	
	rcMyBounds.left = 0;
	rcMyBounds.top = 0;
	rcMyBounds.right = rcWindBounds.right - rcWindBounds.left;
	rcMyBounds.bottom = 320; 		 
	
	DrawText(hdc, (LPCTSTR)_T("hello"),-1 , &rcMyBounds, DT_VCENTER | DT_CENTER);		
		
	DeleteDC( hdc );
	EndPaint(hWnd, &ps);
		
}

